#include "openssl/bio.h"
#include "openssl/ssl.h"
#include "openssl/err.h"

void OpenSSL_SML_add_all_algorithms() {
  OpenSSL_add_all_algorithms();
}

void OpenSSL_SML_load_error_strings() {
  SSL_load_error_strings();
}

void OpenSSL_SML_load_BIO_strings() {
  ERR_load_BIO_strings();
}

int OpenSSL_SML_get_error() {
  return ERR_get_error();
}

const char *OpenSSL_SML_lib_error_string(int err) {
  return ERR_lib_error_string(err);
}

const char *OpenSSL_SML_func_error_string(int err) {
  return ERR_func_error_string(err);
}

const char *OpenSSL_SML_reason_error_string(int err) {
  return ERR_reason_error_string(err);
}

int OpenSSL_SML_write(BIO *b, const void *data, int len) {
  return BIO_write(b, data, len);
}

BIO *OpenSSL_SML_new_connect(char *addr) {
  return BIO_new_connect(addr);
}

void OpenSSL_SML_free_all(BIO *b) {
  BIO_free_all(b);
}

int OpenSSL_SML_do_connect(BIO *b) {
  return BIO_do_connect(b);
}
